"""file: bqueue.py -- correction td6, exercises about bounded queue

"""

import random
import sys

bound = 1000

def empty(): return [range(bound), 0, 0]

def is_empty(q):
  [_,i,j] = q
  return i == j

def queue(q,elt):
  q[1] = (q[1]-1)%bound
  q[0][q[1]] = elt

def dequeue(q):
  x = q[0][q[2]-1]
  q[2] = (q[2]-1)%bound
  return x

## testing
q = empty()
print "empty?", is_empty(q)
for x in range(10):
  queue(q,x)
  print "empty?", is_empty(q)
while not is_empty(q):
  print "dequeue:", dequeue(q)
print "empty?", is_empty(q)
